// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from dataspeed_dbw_gateway:msg/StaticArrays.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_GATEWAY__MSG__DETAIL__STATIC_ARRAYS__FUNCTIONS_H_
#define DATASPEED_DBW_GATEWAY__MSG__DETAIL__STATIC_ARRAYS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "dataspeed_dbw_gateway/msg/rosidl_generator_c__visibility_control.h"

#include "dataspeed_dbw_gateway/msg/detail/static_arrays__struct.h"

/// Initialize msg/StaticArrays message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * dataspeed_dbw_gateway__msg__StaticArrays
 * )) before or use
 * dataspeed_dbw_gateway__msg__StaticArrays__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__StaticArrays__init(dataspeed_dbw_gateway__msg__StaticArrays * msg);

/// Finalize msg/StaticArrays message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__StaticArrays__fini(dataspeed_dbw_gateway__msg__StaticArrays * msg);

/// Create msg/StaticArrays message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * dataspeed_dbw_gateway__msg__StaticArrays__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
dataspeed_dbw_gateway__msg__StaticArrays *
dataspeed_dbw_gateway__msg__StaticArrays__create();

/// Destroy msg/StaticArrays message.
/**
 * It calls
 * dataspeed_dbw_gateway__msg__StaticArrays__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__StaticArrays__destroy(dataspeed_dbw_gateway__msg__StaticArrays * msg);

/// Check for msg/StaticArrays message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__StaticArrays__are_equal(const dataspeed_dbw_gateway__msg__StaticArrays * lhs, const dataspeed_dbw_gateway__msg__StaticArrays * rhs);

/// Copy a msg/StaticArrays message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__StaticArrays__copy(
  const dataspeed_dbw_gateway__msg__StaticArrays * input,
  dataspeed_dbw_gateway__msg__StaticArrays * output);

/// Initialize array of msg/StaticArrays messages.
/**
 * It allocates the memory for the number of elements and calls
 * dataspeed_dbw_gateway__msg__StaticArrays__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__StaticArrays__Sequence__init(dataspeed_dbw_gateway__msg__StaticArrays__Sequence * array, size_t size);

/// Finalize array of msg/StaticArrays messages.
/**
 * It calls
 * dataspeed_dbw_gateway__msg__StaticArrays__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__StaticArrays__Sequence__fini(dataspeed_dbw_gateway__msg__StaticArrays__Sequence * array);

/// Create array of msg/StaticArrays messages.
/**
 * It allocates the memory for the array and calls
 * dataspeed_dbw_gateway__msg__StaticArrays__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
dataspeed_dbw_gateway__msg__StaticArrays__Sequence *
dataspeed_dbw_gateway__msg__StaticArrays__Sequence__create(size_t size);

/// Destroy array of msg/StaticArrays messages.
/**
 * It calls
 * dataspeed_dbw_gateway__msg__StaticArrays__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__StaticArrays__Sequence__destroy(dataspeed_dbw_gateway__msg__StaticArrays__Sequence * array);

/// Check for msg/StaticArrays message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__StaticArrays__Sequence__are_equal(const dataspeed_dbw_gateway__msg__StaticArrays__Sequence * lhs, const dataspeed_dbw_gateway__msg__StaticArrays__Sequence * rhs);

/// Copy an array of msg/StaticArrays messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__StaticArrays__Sequence__copy(
  const dataspeed_dbw_gateway__msg__StaticArrays__Sequence * input,
  dataspeed_dbw_gateway__msg__StaticArrays__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_DBW_GATEWAY__MSG__DETAIL__STATIC_ARRAYS__FUNCTIONS_H_
