// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dataspeed_dbw_gateway:msg/DynamicArrays.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_GATEWAY__MSG__DETAIL__DYNAMIC_ARRAYS__STRUCT_HPP_
#define DATASPEED_DBW_GATEWAY__MSG__DETAIL__DYNAMIC_ARRAYS__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 't_message'
#include "dataspeed_dbw_gateway/msg/detail/example_message__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dataspeed_dbw_gateway__msg__DynamicArrays __attribute__((deprecated))
#else
# define DEPRECATED__dataspeed_dbw_gateway__msg__DynamicArrays __declspec(deprecated)
#endif

namespace dataspeed_dbw_gateway
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DynamicArrays_
{
  using Type = DynamicArrays_<ContainerAllocator>;

  explicit DynamicArrays_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit DynamicArrays_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _t_float_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _t_float_type t_float;
  using _t_double_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _t_double_type t_double;
  using _t_char_type =
    std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other>;
  _t_char_type t_char;
  using _t_bool_type =
    std::vector<bool, typename ContainerAllocator::template rebind<bool>::other>;
  _t_bool_type t_bool;
  using _t_octet_type =
    std::vector<unsigned char, typename ContainerAllocator::template rebind<unsigned char>::other>;
  _t_octet_type t_octet;
  using _t_u8_type =
    std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other>;
  _t_u8_type t_u8;
  using _t_i8_type =
    std::vector<int8_t, typename ContainerAllocator::template rebind<int8_t>::other>;
  _t_i8_type t_i8;
  using _t_u16_type =
    std::vector<uint16_t, typename ContainerAllocator::template rebind<uint16_t>::other>;
  _t_u16_type t_u16;
  using _t_i16_type =
    std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other>;
  _t_i16_type t_i16;
  using _t_u32_type =
    std::vector<uint32_t, typename ContainerAllocator::template rebind<uint32_t>::other>;
  _t_u32_type t_u32;
  using _t_i32_type =
    std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other>;
  _t_i32_type t_i32;
  using _t_u64_type =
    std::vector<uint64_t, typename ContainerAllocator::template rebind<uint64_t>::other>;
  _t_u64_type t_u64;
  using _t_i64_type =
    std::vector<int64_t, typename ContainerAllocator::template rebind<int64_t>::other>;
  _t_i64_type t_i64;
  using _t_string_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _t_string_type t_string;
  using _t_wstring_type =
    std::vector<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>, typename ContainerAllocator::template rebind<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>>::other>;
  _t_wstring_type t_wstring;
  using _t_bounded_string_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _t_bounded_string_type t_bounded_string;
  using _t_bounded_wstring_type =
    rosidl_runtime_cpp::BoundedVector<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>, 8, typename ContainerAllocator::template rebind<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>>::other>;
  _t_bounded_wstring_type t_bounded_wstring;
  using _t_message_type =
    std::vector<dataspeed_dbw_gateway::msg::ExampleMessage_<ContainerAllocator>, typename ContainerAllocator::template rebind<dataspeed_dbw_gateway::msg::ExampleMessage_<ContainerAllocator>>::other>;
  _t_message_type t_message;

  // setters for named parameter idiom
  Type & set__t_float(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->t_float = _arg;
    return *this;
  }
  Type & set__t_double(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->t_double = _arg;
    return *this;
  }
  Type & set__t_char(
    const std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other> & _arg)
  {
    this->t_char = _arg;
    return *this;
  }
  Type & set__t_bool(
    const std::vector<bool, typename ContainerAllocator::template rebind<bool>::other> & _arg)
  {
    this->t_bool = _arg;
    return *this;
  }
  Type & set__t_octet(
    const std::vector<unsigned char, typename ContainerAllocator::template rebind<unsigned char>::other> & _arg)
  {
    this->t_octet = _arg;
    return *this;
  }
  Type & set__t_u8(
    const std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other> & _arg)
  {
    this->t_u8 = _arg;
    return *this;
  }
  Type & set__t_i8(
    const std::vector<int8_t, typename ContainerAllocator::template rebind<int8_t>::other> & _arg)
  {
    this->t_i8 = _arg;
    return *this;
  }
  Type & set__t_u16(
    const std::vector<uint16_t, typename ContainerAllocator::template rebind<uint16_t>::other> & _arg)
  {
    this->t_u16 = _arg;
    return *this;
  }
  Type & set__t_i16(
    const std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other> & _arg)
  {
    this->t_i16 = _arg;
    return *this;
  }
  Type & set__t_u32(
    const std::vector<uint32_t, typename ContainerAllocator::template rebind<uint32_t>::other> & _arg)
  {
    this->t_u32 = _arg;
    return *this;
  }
  Type & set__t_i32(
    const std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other> & _arg)
  {
    this->t_i32 = _arg;
    return *this;
  }
  Type & set__t_u64(
    const std::vector<uint64_t, typename ContainerAllocator::template rebind<uint64_t>::other> & _arg)
  {
    this->t_u64 = _arg;
    return *this;
  }
  Type & set__t_i64(
    const std::vector<int64_t, typename ContainerAllocator::template rebind<int64_t>::other> & _arg)
  {
    this->t_i64 = _arg;
    return *this;
  }
  Type & set__t_string(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->t_string = _arg;
    return *this;
  }
  Type & set__t_wstring(
    const std::vector<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>, typename ContainerAllocator::template rebind<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>>::other> & _arg)
  {
    this->t_wstring = _arg;
    return *this;
  }
  Type & set__t_bounded_string(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->t_bounded_string = _arg;
    return *this;
  }
  Type & set__t_bounded_wstring(
    const rosidl_runtime_cpp::BoundedVector<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>, 8, typename ContainerAllocator::template rebind<std::basic_string<char16_t, std::char_traits<char16_t>, typename ContainerAllocator::template rebind<char16_t>::other>>::other> & _arg)
  {
    this->t_bounded_wstring = _arg;
    return *this;
  }
  Type & set__t_message(
    const std::vector<dataspeed_dbw_gateway::msg::ExampleMessage_<ContainerAllocator>, typename ContainerAllocator::template rebind<dataspeed_dbw_gateway::msg::ExampleMessage_<ContainerAllocator>>::other> & _arg)
  {
    this->t_message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator> *;
  using ConstRawPtr =
    const dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dataspeed_dbw_gateway__msg__DynamicArrays
    std::shared_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dataspeed_dbw_gateway__msg__DynamicArrays
    std::shared_ptr<dataspeed_dbw_gateway::msg::DynamicArrays_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DynamicArrays_ & other) const
  {
    if (this->t_float != other.t_float) {
      return false;
    }
    if (this->t_double != other.t_double) {
      return false;
    }
    if (this->t_char != other.t_char) {
      return false;
    }
    if (this->t_bool != other.t_bool) {
      return false;
    }
    if (this->t_octet != other.t_octet) {
      return false;
    }
    if (this->t_u8 != other.t_u8) {
      return false;
    }
    if (this->t_i8 != other.t_i8) {
      return false;
    }
    if (this->t_u16 != other.t_u16) {
      return false;
    }
    if (this->t_i16 != other.t_i16) {
      return false;
    }
    if (this->t_u32 != other.t_u32) {
      return false;
    }
    if (this->t_i32 != other.t_i32) {
      return false;
    }
    if (this->t_u64 != other.t_u64) {
      return false;
    }
    if (this->t_i64 != other.t_i64) {
      return false;
    }
    if (this->t_string != other.t_string) {
      return false;
    }
    if (this->t_wstring != other.t_wstring) {
      return false;
    }
    if (this->t_bounded_string != other.t_bounded_string) {
      return false;
    }
    if (this->t_bounded_wstring != other.t_bounded_wstring) {
      return false;
    }
    if (this->t_message != other.t_message) {
      return false;
    }
    return true;
  }
  bool operator!=(const DynamicArrays_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DynamicArrays_

// alias to use template instance with default allocator
using DynamicArrays =
  dataspeed_dbw_gateway::msg::DynamicArrays_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dataspeed_dbw_gateway

#endif  // DATASPEED_DBW_GATEWAY__MSG__DETAIL__DYNAMIC_ARRAYS__STRUCT_HPP_
